#ifndef CASE_H_
#define CASE_H_

#include <string>
#include <vector>

#include "KnowledgeModel.h"
#include "Entity.h"
#include "Relation.h"
#include "Feature.h"

namespace TCBR_Representation
{

class CaseBase;

class Case: public Entity
{

public:
	Case(std::string name, TCBR_Representation::CaseBase* cb);
	virtual ~Case();

	void addFeature(std::string type, std::string value);
	std::vector<Feature*> getFeatures();
	Feature* getFeature(std::string name);
	void addFeature(Feature* feature);
	void removeFeature(std::string type);
	bool hasFeature(std::string type);
	void printContent();
};

}

#endif /*CASE_H_*/
