#ifndef CASERETRIEVER_H_
#define CASERETRIEVER_H_

#include <vector>
#include <string>
#include <iostream>

namespace TCBR_Representation
{
	class Case;
	class CaseBase;
	class SimilarityMeasure;

	class CaseRetriever
	{
	protected:
		CaseBase* caseBase_;

	public:
		CaseRetriever(CaseBase* caseBase);
		virtual ~CaseRetriever() {}
		virtual std::vector<std::pair<Case*, double> > retrieveSimilarCases(Case* inputCase) = 0;
	};

	class SimilarityMeasureCaseRetriever: public CaseRetriever
	{
	protected:
		SimilarityMeasure* similarityMeasure_;
	public:
		SimilarityMeasureCaseRetriever(CaseBase* caseBase, SimilarityMeasure* similarityMeasure);
		virtual std::vector<std::pair<Case*, double> > retrieveSimilarCases(Case* inputCase);
	};
};

#endif /*CASERETRIEVER_H_*/
