#ifndef ENTITY_H_
#define ENTITY_H_

#include <vector>
#include <map>
#include <string>

namespace TCBR_Representation
{
	class KnowledgeModel;
	class Relation;

	class Entity
	{

	private:
		std::string name_;
		KnowledgeModel* knowledgeModel_;
		std::multimap<std::string, Relation*> relations_;

	public:
		Entity(std::string n, KnowledgeModel* km);
		Entity(Entity* entity);
		virtual ~Entity();
		void addRelation(Relation*);
		const std::multimap<std::string, Relation*>& getLocalRelations();
		std::vector<Relation*> getLocalRelations(const std::string& type);
		std::vector<Relation*> getLocalRelations(const Entity* type);
		const std::string& getName() const;
		KnowledgeModel* getKnowledgeModel();
		bool equals(Entity*);
		void printContent();
	};
};

#endif /*ENTITY_H_*/
