#ifndef FEATURE_H_
#define FEATURE_H_

#include <string>
#include <vector>
#include <iostream>
#include <sstream>

#include "KnowledgeModel.h"
#include "Entity.h"
#include "Relation.h"
#include "Value.h"

namespace TCBR_Representation
{

class Feature: public Entity
{
private:
	static int featureID_;

public:
	Feature(std::string name, std::string value, TCBR_Representation::KnowledgeModel* knowledgeModel);
	Feature(std::string name, TCBR_Representation::KnowledgeModel* knowledgeModel);
	virtual ~Feature();
	void addValue(std::string value);
	//void addValue(int value);
	//void addValue(float value);
	Value* getValue();
	bool hasValue();
	Entity* getType();
	Entity* getOwner();
	void printContent();
};

inline std::string generateID (int id) {
	std::ostringstream o;
   o << "Feature #";
   o << id;
   return o.str();
}
}
#endif /*FEATURE_H_*/
