#ifndef KNOWLEDGEMODEL_H_
#define KNOWLEDGEMODEL_H_

#include <vector>
#include <string>
#include <map>
#include <iostream>

namespace TCBR_Representation
{
	class Entity;
	class Relation;

	class KnowledgeModel
	{

	private:
		std::vector<Relation*> relations_;
		std::map<std::string, Entity*> entities_;
		std::string name_;

	public:
		KnowledgeModel(std::string n);
		virtual ~KnowledgeModel();

		void addEntity(Entity* e);
		void addRelation(Relation* r);

		Entity* getEntity(std::string n);
		std::string getName();
		std::vector<Relation*>* getRelations(const std::string type);
		std::vector<Relation*>* getRelations(Entity *type);

		bool hasEntity(std::string n);
		bool hasEntity(Entity* e);

		void printAllEntities();
		void printAllRelations();
	};
};

#endif /*KNOWLEDGEMODEL_H_*/
