#ifndef RELATION_H_
#define RELATION_H_

#include <string>

namespace TCBR_Representation
{
class KnowledgeModel;
class Entity;

class Relation
{
private:
	Entity* source_;
	Entity* target_;
	float strength_;
	Entity* type_;
	KnowledgeModel* knowledgeModel_;

public:
	Relation(Entity* s, Entity* t, Entity* type, const float strenght);
	Relation(Entity* s, Entity* t, std::string type, const float strength);
	Relation(Relation* relation);
	virtual ~Relation();
	Entity* getSource() const;
	Entity* getTarget() const;
	float getStrength() const;
	Entity* getType() const;
	KnowledgeModel* getKnowledgeModel() const;
	void printContent();
};
};
#endif /*RELATION_H_*/
