#include "RelationType.h"

namespace TCBR_Representation
{

using namespace std;

///
/// Should the RelationType class exist?
/// Because off RT being an entity a direct relation
/// between entity and the relation type is generated
/// Maybe RT should be an entity, but not inherit the
///	Entity class?
/// It can set up all the proper relations in the constructor
///

RelationType::RelationType(string name, KnowledgeModel* knowledgeModel):
Entity(name, knowledgeModel)
{
	Relation* rel;

	if (!knowledgeModel->hasEntity("RELATION_TYPE"))
	{
		new Entity("RELATION_TYPE", knowledgeModel);
	}
	Entity* root = knowledgeModel->getEntity("RELATION_TYPE");
	Entity* thisType = knowledgeModel->getEntity(name);

	rel = new Relation (thisType, root, "INSTANCE_OF", 1.0);
	thisType->addRelation(rel);

	rel = new Relation (root, thisType, "HAS_INSTANCE", 1.0) ;
	root->addRelation(rel);
}

RelationType::~RelationType()
{
}
}
