#ifndef VALUE_H_
#define VALUE_H_

#include <iostream>
#include <sstream>
#include <string>

#include "KnowledgeModel.h"
#include "Entity.h"
#include "Relation.h"

namespace TCBR_Representation
{

class Value: public Entity
{
private:
	static int idCounter_;
	int type_;
	std::string id_;
	std::string textValue_;
	Entity* thisValue_;

public:
	enum types
	{
		TYPE_INTEGER,
		TYPE_FLOAT,
		TYPE_TEXT
	};

	//Value(int value, TCBR_Representation::KnowledgeModel km);
	//Value(float value, TCBR_Representation::KnowledgeModel km);
	Value(std::string value, TCBR_Representation::KnowledgeModel* km);
	virtual ~Value();

	//int getIntegerValue();
	//float getFloatValue();
	std::string getTextValue();
	int getType();
	void printContent();
};

inline std::string generateValueID(int id)
{
	std::ostringstream o;
	o << "Value #";
	o << id;
	//throw BadConversion("stringify(double)");
	return o.str();
}
}
#endif /*VALUE_H_*/
