#include <iostream>
#include <string>
#include <vector>

#include "Entity.h"
#include "KnowledgeModel.h"
#include "Relation.h"
#include "CaseBase.h"
#include "Case.h"
#include "SimilarityMeasure.h"
#include "CaseRetriever.h"

using namespace std;
using namespace TCBR_Representation;

int main (int argc, char* argv[])
{
	CaseBase cb("TestBase");
	Case* c1 = new Case("Case #1", &cb);
	Case* c2 = new Case("Case #2", &cb);
	Case* c3 = new Case("Case #3", &cb);
	Case* c4 = new Case("Case #4", &cb);
	Case* c5 = new Case("Case #5", &cb);
	Case* c6 = new Case("Case #6", &cb);
	Case* c7 = new Case("Case #7", &cb);
	Case* test = new Case("test", &cb);

	c1->addFeature("Drug", "Aspirin, tablets 500mg");
	c1->addFeature("Substance of effect", "Acetylsalicylic acid");
	c1->addFeature("Dosage", "1 tablet, 3 times a day");
	c1->addFeature("Period of use", "2 days");
	c1->addFeature("Experienced problem by patient", "Vomiting");
	c1->addFeature("Experienced problem by patient", "Nausea");
	c1->addFeature("Solution", "Stopped use of tablets, problems ceased after a couple of hours. Tried other non prescripton pain-relieving drugs with different substance of effect. Paracet, Paracetamol");

	c2->addFeature("Drug", "Aporex, tablets");
	c2->addFeature("Substance of effect", "Paracetamol");
	c2->addFeature("Dosage", "1 tablet, 2 times a day");
	c2->addFeature("Period of use", "3-4 days");
	c2->addFeature("Experienced problem by patient", "Headache");
	c2->addFeature("Experienced problem by patient", "Dizziness");
	c2->addFeature("Solution", "Contacted doctor and got prescribed another drug. Paralgin forte");

	c3->addFeature("Drug", "Paracetamol, tablets");
	c3->addFeature("Substance of effect", "Paracetamol");
	c3->addFeature("Dosage", "1 tablet, 3 times a day");
	c3->addFeature("Period of use", "2 days");
	c3->addFeature("Experienced problem by patient", "Diarrhoea");
	c3->addFeature("Solution", "Not known sideeffect");

	c4->addFeature("Drug", "Panodil Zapp");
	c4->addFeature("Substance of effect", "Paracetamol");
	c4->addFeature("Dosage", "1 tablet, 3 times a day");
	c4->addFeature("Period of use", "1 day");
	c4->addFeature("Experienced problem by patient", "Allergic reaction");
	c4->addFeature("Experienced problem by patient", "Skin rash");
	c4->addFeature("Solution", "Stopped treatment");

	c5->addFeature("Drug", "Morfin Nycomed Pharma, tablets 10mg");
	c5->addFeature("Substance of effect", "Morfinsulfat");
	c5->addFeature("Dosage", "1 tablet, 4 times a day");
	c5->addFeature("Period of use", "2 weeks");
	c5->addFeature("Experienced problem by patient", "Reduced urination");
	c5->addFeature("Experienced problem by patient", "Itching");
	c5->addFeature("Solution", "Consulted physician, decided to continue treatment");

	c6->addFeature("Drug", "Aspirin, tablets 500mg");
	c6->addFeature("Substance of effect", "Acetylsalicylic acid");
	c6->addFeature("Dosage", "1 tablet, 2 times a day");
	c6->addFeature("Period of use", "1 day");
	c6->addFeature("Experienced problem by patient", "Nausea");
	c6->addFeature("Solution", "Stopped use of tablets, problems ceased after a couple of hours. Tried other non prescripton pain-relieving drugs with different substance of effect. Paracet, Paracetamol");

	c7->addFeature("Drug", "Aspirin, tablets 500mg");
	c7->addFeature("Substance of effect", "Acetylsalicylic acid");
	c7->addFeature("Dosage", "1 tablet, 3 times a day");
	c7->addFeature("Period of use", "2 days");
	c7->addFeature("Experienced problem by patient", "Skin rash");
	c7->addFeature("Solution", "Contacted doctor and stopped use of tablets, Skin rash disappeared after one day");


	test->addFeature("Drug", "Aspirin, tablets 500mg");
	test->addFeature("Substance of effect", "Acetylsalicylic acid");
	test->addFeature("Dosage", "1 tablet, 3 times a day");
	test->addFeature("Experienced problem by patient", "Skin rash");

	QueryBiasedSymbolicComparator sc;
	SimilarityMeasureCaseRetriever crsc(&cb, &sc);
	vector<pair<Case*, double> > caseSimilarities = crsc.retrieveSimilarCases(test);




	for (unsigned int i = 0; i < caseSimilarities.size() && i < 10; i++) {
		cout << caseSimilarities[i].first->getName() << " (" << caseSimilarities[i].second << ")" << endl;
	}

	cout << "Most similar case: " << caseSimilarities[0].first->getName() << endl;
	//caseSimilarities[0].first->printContent();
	//cout << "Features of most similar case: " << caseSimilarities[0].first->getName() << endl;
	cout << "Solution to most similar case: " << caseSimilarities[0].first->getFeature("Solution")->getValue()->getTextValue() << endl;

	return 0;
}

